#!/bin/bash
#set -x
TOPIC=/devices/sim/controls

function querryModem()  {
        echo "$1" | atinout - $DEV -  | awk 'NR==2{print $var}' var="$2"
}

function publishResult() {
mosquitto_pub -r -t $TOPIC/$1 -m "$2"
}

if [ -L "/dev/modeminfo" ]; then
        DEV=/dev/modeminfo
	echo "AT+CGMM"  | atinout - /dev/modeminfo - > /var/log/at.log
	MODEL=$(cat /var/log/at.log | awk 'NR==2{print $1}')
	if [[ "$MODEL" == "E3131" ]]; then
		publishResult "CCID" "$(querryModem "AT^ICCID?" 2)"
		echo "$(querryModem "AT^ICCID?" 2)"  > /var/log/at.log
	else
	if [[ "$MODEL" == "SIMCOM_SIM5300E" ]]; then
		publishResult "CCID" "$(querryModem "AT+CCID" 1)"
		echo "$(querryModem "AT^ICCID?" 2)"  > /var/log/at.log
	else
        	publishResult "CCID" "$(querryModem "AT+CCID" 2)"
		echo "$(querryModem "AT^ICCID?" 2)"  > /var/log/at.log
	fi
	fi
        publishResult "RSSI" "$(querryModem "AT+CSQ" 2 | awk -F "," '{print $1}')"
        publishResult "Number" "$(querryModem "AT+CNUM" 2 | awk -F "," '{print $2}' | tr -d "\"")"
	OPERATOR="$(querryModem "AT+COPS?" 2 | awk -F "," '{print $3}' | tr -d "\"")"
	if [[ "$OPERATOR" == "25002" ]]; then 
        	publishResult "Operator" "Megafon"
	else
		if [[ "$OPERATOR" == "25001" ]]; then
               	 	publishResult "Operator" "MTS"
		else
			publishResult "Operator" "$OPERATOR"
		fi
	fi
else
        poff Megafon
        wb-gsm on
        DEV=/dev/ttyAPP0
	sleep 5
	echo "AT+CCID" | atinout - $DEV - > /var/log/at.log
	CCID=$(cat /var/log/at.log | awk 'NR==2{print $2}')
        if [[ -z "$CCID" ]]; then
                CCID=$(cat /var/log/at.log | awk 'NR==2')
        else
                echo "CCID = $CCID"
        fi
	echo "AT+CNUM" | atinout - $DEV - >> /var/log/at.log
        publishResult "CCID" "$(querryModem "AT+CCID" 2)"
	publishResult "CCID" "$CCID"
	grep "imx28-wirenboard55.dtb" /boot/uEnv.txt && publishResult "CCID" "$(querryModem "AT+CCID" 2)"
        publishResult "RSSI" "$(querryModem "AT+CSQ" 2 | awk -F "," '{print $1}')" && wb-gsm on
        publishResult "Number" "$(querryModem "AT+CNUM" 2 | awk -F "," '{print $2}' | tr -d "\"")"
        #publishResult "Operator" "$(querryModem "AT+COPS?" 2 | awk -F "," '{print $3}' | tr -d "\"")"
	OPERATOR="$(querryModem "AT+COPS?" 2 | awk -F "," '{print $3}' | tr -d "\"")"
        if [[ "$OPERATOR" == "25002" ]]; then
             publishResult "Operator" "Megafon"
        else
        	if [[ "$OPERATOR" == "25001" ]]; then
        	     	publishResult "Operator" "MTS"
        	else
			publishResult "Operator" "$OPERATOR"
        	fi
        fi

        pon Megafon
fi
