#!/bin/sh

PORT=/dev/ttyUSB3

GSM_STATUS_PIN=1

function debug() 
{
    echo $1 1>&2
}

function gpio_export() 
{
    if [[ ! -e  /sys/class/gpio/gpio$1  ]]; then
        echo $1 > /sys/class/gpio/export
    fi
}

function gpio_set_dir() 
{
    CUR_DIRECTION=`cat "/sys/class/gpio/gpio$1/direction"`
    if [[ ! $CUR_DIRECTION = "$2" ]]; then
        echo "$2" > /sys/class/gpio/gpio$1/direction
    fi

}

function gpio_set_value() 
{
    echo $2 > /sys/class/gpio/gpio$1/value
}

function gpio_get_value() 
{
    cat /sys/class/gpio/gpio$1/value
}

function toggle_modem() 
{
    debug "toggle GSM modem state using PWRKEY"

    gpio_set_value $GPIO_GSM_PWRKEY 0
    sleep 1
    gpio_set_value $GPIO_GSM_PWRKEY 1
    sleep 1
    gpio_set_value $GPIO_GSM_PWRKEY 0
}

function reset_modem() 
{
        debug "Resetting GSM modem using RESET pin"
        echo 1 > ${RESET_GPIO}/value
        sleep 0.5
        echo 0 > ${RESET_GPIO}/value
        sleep 0.5
}

function get_sim_status() 
{
    REPORT_FILE=`mktemp`
    /usr/sbin/chat -s -r $REPORT_FILE  TIMEOUT 5 ABORT "ERROR" REPORT "\r\n" "" "AT#QSS?" OK ""  > $PORT < $PORT	
    INSERTED=`cat $REPORT_FILE | sed -n 2p | awk -F , '{print $2}'`
    echo $INSERTED
    rm $REPORT_FILE
}

function set_slot_gpio()
{
    /usr/sbin/chat -v TIMEOUT 1 ABORT "ERROR" ABORT "BUSY" "" "AT#GPIO=$1" OK "" > $PORT < $PORT
}

function simdet()
{
    /usr/sbin/chat -s -r  $REPORT_FILE  TIMEOUT 1 ABORT "ERROR" REPORT "\r\n" "" "AT#SIMDET=0" OK ""  > $PORT < $PORT
    /usr/sbin/chat -s -r  $REPORT_FILE  TIMEOUT 5 ABORT "ERROR" REPORT "\r\n" "" "AT#SIMDET=1" OK ""  > $PORT < $PORT	
}

function active_slot_a()
{
        set_slot_gpio "3,0,1"
        set_slot_gpio "2,1,1"
        set_slot_gpio "4,0,1"
	simdet
}

function active_slot_b()
{
        set_slot_gpio "3,1,1"
        set_slot_gpio "2,0,1"
        set_slot_gpio "4,1,1"
	simdet
}



